// Queue.cpp
#include <cassert>
#include "Queue.h"
#include <iostream>
#include <iostream>

//template <class T>
Queue::Queue(int m) : _max(m), _count(0) {
    _a = new char[_max];
    assert(_a != 0);
}

Queue::~Queue() {
    delete [] _a;
}

char Queue::front() const {
    assert (_count > 0);
    return _a[_count-1];
}

char Queue::back() const {
    assert (_count > 0);
    return _a[0];
}

bool Queue::is_empty() const {
    return (_count == 0); //bool(_count == 0);
}

bool Queue::is_full() const {
    return (_count == _max); //bool(_count == _max);
}

void Queue::enter(const char x) {
    _count++;
    assert(_count < _max);
    for(int i = _count-2; i >= 0; --i)
        _a[i+1]=_a[i];
    _a[0] = x;
}

char Queue::leave() {
    assert(_count > 0);
    return _a[--_count];
}

void Queue::print() {
    //char tmp;
    std::cout << "\ncount = " << _count << std::endl;
    int cnt = _count;
    //Queue temp(_count);
    //while(!((*this).is_empty())) { //copy the Queue to temp
    while(cnt>0) {
        (*this).enter((*this).leave());
        std::cout << (*this).back();
        cnt--;
    }
//    while(!(temp.is_empty())) { //copy temp back to the Queue
//        (*this).enter(temp.leave());
//        //std::cout << temp.top();
//    }
//    *this = temp;
//    std::cout << "\nAfter the assignment, *this = temp, (*this).top() = "
//              << (*this).top() << std::endl;
//    //(*this).push(temp.pop());
}

int Queue::size() {
    return _count;
}
