// Random.h
#include <ctime>
#include <iostream>
#include <climits>
//#include <cmath>
#include <ctime>

typedef unsigned long ulong;
const int MAX = INT_MAX;              // = 2,147,483,647 or 32,767

class Random {
public:
    Random(ulong seed=0);
    void seed(ulong seed=0);       // allows client to reset _seed
    int integer(ulong hi=MAX, ulong lo=1);
    double real();
private:
    ulong _seed;             // INVARIANT: 0 <= _seed <= ULONG_MAX
    void _randomize();                             // resets _seed
};

Random::Random(ulong s) {
    if(s > 0) _seed = s;
    else _seed = time(NULL);
    _randomize();
}

void Random::seed(ulong s) {
    if(s > 0) _seed = s;
    else _seed = time(NULL);
    _randomize();
}

int Random::integer(ulong hi, ulong lo) {
    _randomize();
    return _seed/10 % (hi - lo + 1) + lo;
}

double Random::real() {
    _randomize();
    return double(_seed)/ULONG_MAX;
}

void Random::_randomize() {
    _seed = (1103515245*_seed + 123456789) % ULONG_MAX;
}
