//  Fundamentals of Computing with C++ by John R. Hubbard
//  Copyright McGraw-Hill, 1999
//  Example 7.18 on page 154
//  A Stack class

#include <cassert>
#include <iostream>
#include <utility>
#include <cstdlib>
#include <ctime>
#include "Queue.h"
#include "Stack.h"
#include "Random.h"
#include "Ratio.h"
#include "Dice.h"


int main() {

//    FCCPP7-8
//    Stack st;
//    std::std::cout << "\nAfter pushing a, b, and c, the stack is ";
//    st.push('a');
//    st.push('b');
//    st.push('c');
//    st.print();
//    std::std::cout << "\nAfter leaving the print() function, st.top() = "
//              << st.top() << std::std::endl;
//    st.pop();
//    std::std::cout << "\nAfter popping the top off the stack, it is ";
//    st.print();

//    FCCPP7-9
//    Queue q1;
//    for(int i = 65; i < 91; ++i)
//        q1.enter(static_cast<char>(i));
//    std::std::cout << "\nThe queue q1 = ";
//    q1.print();

//    FCCPP7-10
//    Random random;
//    const int NUM=10;
//    const int CNT=10000;
//    const int MEAN=CNT/NUM;
//    int bucket[NUM] = {0};
//    int n, ssdev=0;
//    for (int i=0; i < CNT; i++) {
//        n = random.integer(NUM-1,0);  // 0 <= n <= 9
//        bucket[n]++;                  // count n
//        ssdev += (n-MEAN)*(n-MEAN);   // sum its deviation squared
//    }
//    for (int j=0; j < NUM; j++)
//        std::cout << "\t" << j << ": " << bucket[j] << std::endl;
//    std::cout << "Standard deviation = " << sqrt(ssdev/CNT) << std::endl;
//    for (int i=0; i < 25; i++)
//        std::cout << random.integer(2) << ", ";
//    std::cout << std::endl;
//    for (int i=0; i < 25; i++)
//        std::cout << random.integer(6) << ", ";
//    std::cout << std::endl;
//    for (int i=0; i < 20; i++)
//        std::cout << random.integer(99,10) << "    "
//             << random.integer(9999,1000) << "    "
//             << random.integer(999999,100000) << "    "
//             << random.real() << std::endl;
//    std::cout << std::endl << 1103515245*100000 + 123456789 << std::endl;
//    std::cout << std::endl<< 1103515245*100000 + 123456789 % ULONG_MAX<< std::endl;

    // Create a random ratio
//    Random rLLongNum;
//    long long num = static_cast<long long>(rLLongNum.integer(INT_MAX -1,1));
//    long long den = static_cast<long long>(rLLongNum.integer(INT_MAX -1,1));
//    std::cout << "\nWe created a random integer = " << num;
//    std::cout << "\nand another one = " << den;
//    Ratio r(num, den);
//    std::cout << "\nWe create the Ratio = num/den = " << r;

    //FCCPP7-11
//    int bucket[13]={0};
//    //srand(unsigned(time(0)));
//    Dice d;
//    //std::cout << "\nYou rolled a " << d.toss() << std::endl;
//    int t;
//    d.seed();
//    for(int i = 0; i < 10000; i++) {
//        t=d.toss();
//        bucket[t]++;
//    }
//    for(int i = 0; i < 13; ++i)
//        std::cout<<bucket[i] << ", ";
    Random r;
    Queue q(10000);
    for(int i = 0; i < 1000; ++i)
        q.enter(static_cast<char>(r.integer(90,65)));
    std::cout<<std::endl<<"\nWe created 1000 random characters: " << std::endl;
    q.print();
    std::cout<<"\nThere are " << q.size()<<" elements in the queue." << std::endl;
    return 0;
}
